       subroutine schur2(M, R, gamma, EM)
       real R(0:M), gamma(M)

       parameter (MAX = 50)
       real g(0:MAX, 0:MAX)
       integer p

       g(0, 0) = R(0)

       do 1  k = 1, M
             g(0, k) = 2 * R(k)
             g(1, k) = R(k) + R(k-1)
1     continue

       c = 0
       do 2  p = 0, M-2
             alpha = g(p+1, p+1) / g(p, p)
             c = -1 + alpha / (1 - c)
             gamma(p+1) = c
             do 3  k = p+2, M
3                  g(p+2,k)=g(p+1,k)+g(p+1, k-1) - alpha * g(p, k-1)
2     continue

       alpha = g(M, M) / g(M-1, M-1)
       gamma(M) = -1 + alpha / (1 - c)
       EM = g(M, M) * (1 - gamma(M))

       return
       end
