c--------------------------- snap.for ---------------------------

       subroutine snap(L, k, P, M, y, iseed)
       real k(L), P(L)
       complex y(0:M)

       parameter (LMAX = 20)
       complex A(LMAX)

       pi = 4 * atan(1.)
       sigma = 1 / sqrt(2.0)

       do 1  i = 1, L
             phi = 2 * pi * ran(iseed)
             A(i) = sqrt(P(i)) * cexp(cmplx(0., phi))
1     continue

       do 2  j = 0, M
             v1 = gran(0., sigma, iseed)
             v2 = gran(0., sigma, iseed)
             y(j) = cmplx(v1, v2)
             do 2  i = 1, L
                   y(j) = y(j) + A(i) * cexp(cmplx(0., -j * k(i)))
2     continue

       return
       end
